<?php
/**
 * @file
 * Preproccess functions for HTML.
 */

/**
 * Implements da_vinci_preprocess_html().
 */
function da_vinci_preprocess_html(&$variables) {
  if (isset($variables['node'])) {
    // For full nodes.
    $variables['classes_array'][] = ($variables['node']) ? 'full-node' : '';
    // For forums.
  }
  if (module_exists('panels') && function_exists('panels_get_current_page_display')) {
    $variables['classes_array'][] = (panels_get_current_page_display()) ? 'panels' : '';
  }

  // Since menu is rendered in preprocess_page we need to detect it
  // here to add body classes.
  $has_main_menu = theme_get_setting('toggle_main_menu');
  $has_secondary_menu = theme_get_setting('toggle_secondary_menu');

  // Add extra classes to body for more flexible theming.
  if ($has_main_menu or $has_secondary_menu) {
    $variables['classes_array'][] = 'with-navigation';
  }

  if ($has_secondary_menu) {
    $variables['classes_array'][] = 'with-subnav';
  }

  if (!empty($variables['page']['featured'])) {
    $variables['classes_array'][] = 'featured';
  }

  if ($variables['is_admin']) {
    $variables['classes_array'][] = 'admin';
  }

  if (!empty($variables['page']['header_top'])) {
    $variables['classes_array'][] = 'header_top';
  }

  if (!empty($variables['page']['sidebar_first']) && !empty($variables['page']['sidebar_second'])) {
    $variables['classes_array'][] = 'layout-two-sidebars';
  }
  elseif (!empty($variables['page']['sidebar_first'])) {
    $variables['classes_array'][] = 'layout-one-sidebar layout-sidebar-first';
  }
  elseif (!empty($variables['page']['sidebar_second'])) {
    $variables['classes_array'][] = 'layout-one-sidebar layout-sidebar-second';
  }
  else {
    $variables['classes_array'][] = 'layout-no-sidebars';
  }

  // Add unique classes for each page and website section.
  $path = drupal_get_path_alias($_GET['q']);
  $temp = explode('/', $path, 2);
  $section = array_shift($temp);
  $page_name = array_shift($temp);

  // Add template suggestions.
  $variables['theme_hook_suggestions'][] = "page__section__" . $section;
  $variables['theme_hook_suggestions'][] = "page__" . $page_name;

}
